import platform

_getcpumemory = None
_getcpunum = None
_getcputype = None
_getmemorysize = None
_getdisk = None
_getnet = None
_getproc = None
_getlogevent = None
_initlogevent = None

system = platform.system().lower()
if 'linux' == system:
    import cpu_memory as cpu_memory
    _getcpumemory = cpu_memory.GetCpuMemory

    import system_info_linux as system_info
    _getcpunum = system_info.GetCPUNum
    _getcputype = system_info.GetCPUType
    _getmemorysize = system_info.GetMemorySize
    import disk_linux
    _getdisk = disk_linux.getDisk
    import network_linux
    _getnet = network_linux.GetNicUtil
    import proc_linux
    _getproc = proc_linux.GetProc
    import log_event_linux
    _getlogevent = log_event_linux.getNewLogEvents
    _initlogevent = log_event_linux.initFileLogWatcher
elif 'sunos' == system:
    import cpu_memory_sunos as cpu_memory
    _getcpumemory = cpu_memory.GetCpuMemory

    import system_info_sunos 
    _getcpunum = system_info_sunos.GetCPUNum
    _getcputype = system_info_sunos.GetCPUType
    _getmemorysize = system_info_sunos.GetMemorySize
    import disk_sunos 
    _getdisk = disk_sunos.getDisk
    import network_sunos
    _getnet = network_sunos.GetNicUtil
    import proc_sunos
    _getproc = proc_sunos.GetProc
    import log_event_linux
    _getlogevent = log_event_linux.getNewLogEvents
    _initlogevent = log_event_linux.initFileLogWatcher

def GetCpuMemory():
    return _getcpumemory()

def GetCPUNum():
    return _getcpunum()

def GetCPUType():
    return _getcputype()

def GetMemorySize():
    return _getmemorysize()

def GetUptime():
    import time
    return int(time.time())

def GetDisk():
    return _getdisk()

def GetNicUtil():
    return _getnet()

def GetProc():
    return _getproc()

def GetLogEvents():
    return _getlogevent()

def InitLogEvent():
    _initlogevent()

